<template>
  <div class="container-fluid mb-5 mt-4">
    <div class="row">
      <div class="col-md-3 mb-4">
        <CustomerMenu />
      </div>
      <div class="col-md-9 mb-4">
        <div class="card border-0 rounded shadow">
          <div class="card-body text-left">
            <h5 class="font-weight-bold text-left">
              Detail Order
            </h5>
            <hr />
            <table class="table table-bordered text-uppercase">
              <!-- invoice -->
              <tr>
                <td style="width: 25%">No. Invoice</td>
                <td>{{ detailOrder.invoice }}</td>
              </tr>
              <!-- full name -->
              <tr>
                <td>Full Name</td>
                <td>{{ detailOrder.name }}</td>
              </tr>
              <!-- phone number -->
              <tr>
                <td>Phone Number</td>
                <td>0{{ detailOrder.phone }}</td>
              </tr>
              <!-- courier, service, and cost -->
              <tr>
                <td>Courier / Service / Cost</td>
                <td>
                  {{ detailOrder.courier }} / {{ detailOrder.service }} / Rp {{ detailOrder.cost_courier }}
                </td>
              </tr>
              <!-- address -->
              <tr>
                <td>Address</td>
                <td>
                  {{ detailOrder.address }}, 
                  <span v-if="detailOrder.cities && detailOrder.cities.name">{{ detailOrder.cities.name }}</span>,  
                  <span v-if="detailOrder.provinces && detailOrder.provinces.name">{{ detailOrder.provinces.name }}</span>
                </td>
              </tr>
              <!-- grand total -->
              <tr>
                <td>Grand Total</td>
                <td>Rp {{ detailOrder.grand_total }}</td>
              </tr>
              <!-- status -->
              <tr>
                <td>Status</td>
                <td>
                  <button @click="payment(detailOrder.snap_token)" v-if="detailOrder.status == 'pending'"
                    class="btn btn-primary border-0">
                    Pay Now
                  </button>
                  <button v-else-if="detailOrder.status == 'success'" class="btn btn-success">
                    {{ detailOrder.status }}
                  </button>
                  <button v-else-if="detailOrder.status == 'expired'" class="btn btn-warning">
                    {{ detailOrder.status }}
                  </button>
                  <button v-else-if="detailOrder.status == 'failed'" class="btn btn-danger">
                    {{ detailOrder.status }}
                  </button>
                </td>
              </tr>
            </table>
          </div>
        </div>

        <div class="card border-0 rounded shadow mt-4">
          <div class="card-body">
            <h5 class="font-weight-bold text-left">Detail Product</h5>
            <div v-for="product in productInOrder" :key="product.id">
              <hr />
              <div class="row mt-2">
                <!-- product image -->
                <div class="col-md-4 text-left">
                  <img :src="product.image" style="border-radius: 0.5rem"
                    class="img-fluid" />
                </div>
                <!-- product title -->
                <div class="col-md-4 mt-2 mt-md-0">
                  <h5 class="text-left">
                    <!-- product name -->
                    <div class="product-title mb-2">
                      <strong style="font-size: 1rem">{{ product.product_name }}</strong>
                    </div>
                    <!-- product quantity -->
                    <span class="mt-2">
                      <div class="product-quantity">
                        Quantity: {{ product.qty }}
                      </div>
                    </span>
                  </h5>
                </div>
                <!-- product price -->
                <div class="col-md-4 text-left">
                  <h5>
                    <div class="product-price">
                      <strong>Rp {{ moneyFormat(product.price) }}</strong>
                    </div>
                  </h5>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
//import customer menu component
import CustomerMenu from "@/components/CustomerMenu";
import { computed, onMounted } from "vue";
import { useStore } from "vuex";
import { useRoute, useRouter } from "vue-router";

export default {
  name: "OrderShowComponent",

  components: {
    // customer menu component
    CustomerMenu,
  },

  setup() {
    // store vuex
    const store = useStore();

    // router and route vuer router
    const route = useRoute();
    const router = useRouter();

    // mounted
    onMounted(() => {
      //panggil action "detailOrder" di dalam module "order" di Vuex
      store.dispatch("order/detailOrder", route.params.snap_token);
    });

    // computed
    const detailOrder = computed(() => {
      //panggil getter dengan nama "detailOrder" di dalam module "order" Vuex
      return store.getters["order/detailOrder"];
    });

    // computed
    const productInOrder = computed(() => {
      // panggil getter dengan nama "productInOrder" di dalam module "order" Vuex
      return store.getters["order/productInOrder"];
    });

    // function payment "Midtrans"
    function payment(snap_token) {
      window.snap.pay(snap_token, {
        onSuccess: function () {
          router.push({
            name: "detail_order",
            params: { snap_token: snap_token },
          });
        },
        onPending: function () {
          router.push({
            name: "detail_order",
            params: { snap_token: snap_token },
          });
        },
        onError: function () {
          router.push({
            name: "detail_order",
            params: { snap_token: snap_token },
          });
        },
      });
    }

    return {
      store,
      route,
      router,
      detailOrder,
      productInOrder,
      payment,
    };
  },
};
</script>


<style scoped>
@media screen and (min-width: 400px) and (max-width: 576px) {
  img {
    margin-bottom: 10px;
    height: 125px;
    width: 50% !important;
  }

  .product-title, .product-quantity, .product-price {
    font-size: 16px;
  }
}
@media screen and (min-width: 577px) and (max-width: 772px) {
  img {
    height: 180px;
    width: 50% !important;
  }

  .product-title, .product-quantity, .product-price {
    font-size: 16px;
  }
}
@media screen and (min-width: 773px) and (max-width: 992px) {
  img {
    width: 100% !important; 
  }
}
@media screen and (min-width: 993px){
  img {
    height: 230px;
    width: 100% !important; 
  }
}
</style>